/* $VER: lha2lzx.rexx 1.2 (9.6.98) Richard Burke */

PARSE ARG Type					/* Store the argument given at the command line in LhA2LZX, which determines which process to carry out */

IF Type = 'tilde' THEN SIGNAL Tilde1		/* Go to the label 'Tilde1', to get rid of the tilde in filenames */
IF Type = 'size' THEN SIGNAL Size1		/* To get the amount of space left on disk */
IF Type = 'comment' THEN SIGNAL Comment1	/* To change asterisks in filecomments to plus signs */
IF Type = 'prot' THEN SIGNAL Prot1		/* To get the protection of the old archive */


/* ************************************************************************ */


Tilde1:
CALL OPEN('File','env:nl2zl','R')	/* Open the file containing the filename of the archive */
Name = READLN('File')			/* Read the filename */
Name1 = TRANSLATE(Name,'_','~')		/* Change the tilde to an underscore */
Length = WORDLENGTH(Name,1)		/* Get the length of the filename */
Pos = 1					/* Set the character position to an initial value */

DO UNTIL Length = Pos + 4		/* Just in case there is more than one tilde in the filename... */
	Pos = INDEX(Name,'~',Pos)	/* Find the numerical position of the (next) tilde */
	IF Pos = 0 THEN SIGNAL Fin	/* Go to the label 'Fin' if there are no more tilde's */
	Pos = Pos - 1			/* Go to the previous character position  - the one BEFORE the tilde */
	Name = INSERT("'",Name,Pos)	/* Insert an apostrophe before the tilde */
	Pos = Pos + 3			/* Jump to the character after the tilde */
END					/* End of the 'DO UNTIL...' statement */

Fin:					/* The label 'Fin' */
CALL CLOSE('File')			/* Close the file containing the old filename, so that it can be renamed */
ADDRESS COMMAND				/* Address AmigaDOS */
'rename "'Name'" AS "'Name1'"'		/* Rename the old file to the new name, e.g. "rename old'~file TO old_file" */
'echo "'Name1'" >env:nl2zl'		/* Copy the new filename over the old */
'echo "*"$nl2zl*"" >env:nl2zldfl'	/* Copy the new filname surrounded by quotes over the old (which was surrounded by quotes) */
EXIT


/* ************************************************************************ */


Size1:    				/* This just gets rid of the carriage return */
CALL OPEN('File','env:nl2zvolsz','R')	/* and the line feed at the end of the 'env:nl2zvolsz' */
Text = READLN('File')			/* file created by 'inf' */
CALL CLOSE('File')
Text = STRIP(Text,'T','0a'x'0d'x)	/* Strip the trailing CR and LF */
CALL OPEN('File','env:nl2zvolsz','W')
CALL WRITECH('File',Text)
CALL CLOSE('File')
EXIT


/* ************************************************************************ */


Comment1:
CALL OPEN('File','env:nl2zcom','R')	/* Open the file containing the comment of the archive */
Name = READLN('File')			/* Read the comment */
Name1 = TRANSLATE(Name,'+','*')		/* Change the asterisk to a plus */
CALL CLOSE('File')			/* Close the file containing the old comment */
CALL OPEN('File','env:nl2zcom','W')
CALL WRITECH('File',Name1)		/* Write the new comment */
EXIT


/* ************************************************************************ */


Prot1:
CALL OPEN('File','env:nl2zprot','R')	/* Open the file containing the attributes of the archive */
Atts = READLN('File')			/* Read the attributes */
Atts = STRIP(Atts,,'-')			/* Remove the hyphens from each end of the string */
CALL CLOSE('File')
CALL OPEN('File','env:nl2zprot','W')
CALL WRITECH('File',Atts)		/* Write the attributes without the starting/trailing hyphens */
CALL CLOSE('File')

CALL OPEN('File','env:nl2zprot','R')	/* Open the file containing the attributes of the archive to reset the marker position */
Length = LENGTH(Atts)			/* Get the length of the new list of attributes and hyphens */
Pos = 1					/* Set the marker position */
Atts1 = ' '				/* Set the new output string to a single space ready for concatenation */
IF Length = '0' THEN SIGNAL Fin1	/* If there's no attributes then close the file */

DO WHILE Length >= Pos
Char = READCH('File')			/* Get the next character from the file */
IF Char='h'^Char='s'^Char='p'^Char='a'^Char='r'^Char='w'^Char='e'^Char='d' THEN DO	/* if the current character is an attribute character... */
		Atts1 = Atts1||Char	/* ...concatenate (add) it onto the list of attributes found so far */
		END
Pos = Pos + 1
END

Fin1:
CALL CLOSE('File')			/* Close the file from reading */
CALL OPEN('File','env:nl2zprot','W')	/* Re-open the file for writing */
CALL WRITECH('File',Atts1)
CALL CLOSE('File')
EXIT
